#ifndef lint
static char	*sccsid = "@(#)ahbs.c	1.8	(Berkeley) 1/11/88";
#endif

#include "common.h"

FILE		*fp;
int		method;
static char	*verbiage[] = {
	"head and body follow",
	"head follows",
	"body follows",
	"request text separately"
};

/*
 * {ARTICLE,HEAD,BODY,STAT} <messageid>|articlenum
 *
 * Retrieve article, head, body, or stat, depending on the
 * command we were invoked with.
 */

ahbs(argc, argv)
int		argc;
char		*argv[];
{
    char		artbuf[MAXPATHLEN], art_id[MAXBUFLEN];
    register char	c;

    if (argc > 2) {
        state_cb.state = SINGLE_RESP_STATE;
	(void) sprintf(response_text, 
                "%d Usage: %s <message-id>|article_number.\r\n",
		ERR_CMDSYN,argv[0]);
	return;
    }

    if ((c = *argv[0]) == 'a' || c == 'A')
	method = ARTICLE;
    else if ((c == 's' || c == 'S'))
	method = STAT;
    else
	method = ((c == 'h' || c == 'H') ? HEAD : BODY);

    if (argc == 2 && *argv[1] == '<') {	/* Message ID */
	fp = openartbyid(argv[1]);
	if (fp == NULL) {
            state_cb.state = SINGLE_RESP_STATE;
	    (void) sprintf(response_text, 
                        "%d No article by message-id %s, sorry.\r\n",
			ERR_NOART, argv[1]);
	    return;
	}
	if (check_ngperm(fp) == 0) {
            state_cb.state = SINGLE_RESP_STATE;
	    (void) sprintf(response_text, 
                        "%d Can't give that to you, sorry.\r\n",
			ERR_ACCESS);
	    (void) fclose(fp);
	    return;
	}
        state_cb.state = AHBS_STATE;
	(void) sprintf(response_text, "%d 0 %s Article retrieved, %s.\r\n",
		OK_ARTICLE + method, argv[1], verbiage[method]);
	return;
    }

    /* Else we're trying to read */

    if (!ingroup) {
        state_cb.state = SINGLE_RESP_STATE;
	(void) sprintf(response_text, 
                        "%d You are not currently in a newsgroup.\r\n",
			ERR_NCING);
	return;
    }

    if (argc == 1) {
	if (art_ptr < 0 || art_ptr >= num_arts) {
            state_cb.state = SINGLE_RESP_STATE;
	    (void) sprintf(response_text, 
                        "%d No article is currently selected.\r\n",
			ERR_NOCRNT);
	    return;
	}
	(void) sprintf(artbuf, "%d", art_array[art_ptr]);
    } else
	(void) strcpy(artbuf, argv[1]);

    if (!valid_art(artbuf)) {
        state_cb.state = SINGLE_RESP_STATE;
        (void) sprintf(response_text, "%d Invalid article number: %s.\r\n",
			ERR_NOARTIG, artbuf);
	return;
    }

    while (open_valid_art(artbuf, art_id) == NULL) {
	if (argc > 1) {
            state_cb.state = SINGLE_RESP_STATE;
	    (void) sprintf(response_text, "%d Invalid article number: %s.\r\n",
				ERR_NOARTIG, artbuf);
	    return;
	} else {
	    if (++art_ptr >= num_arts) {
                state_cb.state = SINGLE_RESP_STATE;
		(void) sprintf(response_text, "%d Invalid article number.\r\n",
					ERR_NOARTIG);
		return;
	    }
	    (void) sprintf(artbuf, "%d", art_array[art_ptr]);
	}
    }

    if (method == STAT)
        state_cb.state = SINGLE_RESP_STATE;
    else
        state_cb.state = AHBS_STATE;
    (void) sprintf(response_text, "%d %s %s Article retrieved; %s.\r\n",
		OK_ARTICLE + method, artbuf, art_id, verbiage[method]);
    fp = art_fp;
    if (argc > 1)
	art_ptr = findart(artbuf);
}



/*
 * ahbs_read - read the contents of a file to response_text, doing
 * the necessary cr-lf additions at the end.  Finish with
 * a "." on a line by itself.
 *
 *
 *	Returns:	Nothing.
 *
 *	Side effects:	Changes current position in file.
 */

ahbs_read()
{
    char		line[NNTP_STRLEN];
    static int          header_done = 0;
    register char	*cp;

    switch (header_done) {
    case 0 :
        while (fgets(line, sizeof(line)-6, fp) != NULL && *line != '\n') {
	    if (method == BODY)	/* We need to skip this anyway */
	        continue;
	    cp = index(line, '\n');
	    if (cp != NULL)
	        *cp = '\0';
	    if (*line == '.')
	        (void) sprintf(response_text, ".%s", line);
            else
                (void) strcpy(response_text, line);
	    if (cp == NULL) {
	        for (;;) {
	            if ((fgets(line, sizeof(line)-6, fp) == NULL)
				    || (index(line, '\n') != NULL))
		        break;
	        }
	    }
            return; /* let a call to get_server get this line */
        }

        if (method == HEAD) {
            (void) strcpy(response_text, ".");
            break; /* we be done */
        } else if (method == ARTICLE) {
            response_text[0] = '\0';
            header_done = 1;
            return; /* let a call to get_server get this line */
        }
        header_done = 1;
        /* fall through */

    default : /* reading the body */

        if (fgets(line, sizeof(line)-6, fp) != NULL) {
	    cp = index(line, '\n');
	    if (cp != NULL)
	        *cp = '\0';
	    if (*line == '.')
	        (void) sprintf(response_text, ".%s", line);
            else
	        (void) strcpy(response_text, line);
	    if (cp == NULL) {
	        for (;;) {
		    if ((fgets(line, sizeof(line)-6, fp) == NULL)
				    || (index(line, '\n') != NULL))
		        break;
	        }
	    }
            return; /* let a call to get_server get this line */
        }
    }
    state_cb.state = NULL_STATE;
    (void) strcpy(response_text, "."); 
    header_done = 0;
    (void) fclose(fp);
}
