/*
 * Common declarations, includes, and other goodies.
 *
 * @(#)$Header: common.h,v 1.38 91/02/02 15:55:21 sob Exp $
 */


#include "conf.h"
#include "nntp.h"
#include "state.h"

#include <stdio.h>
#ifndef BSD_42
#include <sys/types.h>
#endif /* BSD_42 */
#include <sys/param.h>
#include <sys/stat.h>
#include <errno.h>
#include <ctype.h>
#include <pwd.h>
#include <sys/file.h>
#ifdef BSD2_10
#include <short_names.h>
#endif /* BSD2_10 */

#ifdef USG
extern struct passwd *getpwent(), *getpwuid(), *getpwnam();
#define iolen_t unsigned
# include <string.h>
#else /* not USG */
# include <strings.h>
# include <sys/wait.h>
#define iolen_t int
#endif /* not USG */

#ifdef NDIR
#ifdef M_XENIX
# include <sys/ndir.h>
#else
# include <ndir.h>
#endif
#else /* not NDIR */
# include <sys/dir.h>
#endif /* not NDIR */

#ifdef FCNTL
# include <fcntl.h>
#endif /* FCNTL */

#ifdef ultrix
extern char * index();
extern char * rindex();
#endif

/*
 * <dbm.h> stupidly defines NULL, which is why the following
 * brain death is necessary.
 */

#ifdef DBM
# ifdef DBZ
#  include <dbz.h>
# else /* DBZ */
#  undef NULL
#  include <dbm.h>
#  undef NULL
#  define NULL	0
# endif /* DBZ */
#else
# ifdef NDBM
#  include <ndbm.h>
# endif /* NDBM */
#endif /* DBM */

/*
 * Some generic maximums.
 */

#ifndef MAXPATHLEN
#define	MAXPATHLEN	1024
#endif

#define	MAXBUFLEN	1024

/*
 * For ahbs_read()
 */
#define ARTICLE 0
#define HEAD    1
#define BODY    2
#define STAT    3

/*
 * For "ngmatch()"
 */

#define	ALLBUT	1

#define	valid_art(s)	(atoi(s) != 0)

extern	char	*gets(), *fgets();
extern	FILE	*open_valid_art();
extern	FILE	*openartbyid();
extern	char	*gethistent();
extern	int	restreql();
extern	int	s1strneql();	/* for ngmatch */

#ifdef XTHREAD
extern	char	*threaddirpath;
extern	char	*threadfile;
#endif

extern	char	**group_array;
extern	char	*actbuf;
extern	int	num_groups;
extern	int	ingroup;
#ifdef DYNAMIC_ART_ARRAY
extern	int	*art_array;
extern	unsigned int size_art_array;
#else
extern	int	art_array[];
#endif
extern	int	art_ptr;
extern	FILE	*art_fp;
extern	int	num_arts;
extern	char	**ngpermlist;
extern	int	ngpermcount;

/*
 * NetNews/CD additions - April 1992
 */

extern  char    *help_text[];
extern  char    response_text[];
extern  char	iso_extension[];
extern  STATE_CB state_cb;

/*
 * Prototype functions to allow gcc to check calling parameters
 */
 
#include "proto.h"
