/*
** @(#)findpath.c	1.1 4/24/92
**
**  This function is used to locate a path to a newsgroup directory.
** ISO 9660 directory naming is limited to 8 characters with a 3 character
** optional extension.  In order to hide the ugly nature of the ISO 9660
** naming from the users and readers, this function is used to lookup
** the actual location on the CD-ROM of the file.  
**/
#include <stdio.h>
#include "common.h"
#include "spooldir.h"

int findpath(ngname, diskpath, libpath, type)
    char *ngname;
    char *diskpath;
    char *libpath;
    int type;
{
    char *fgets();
    char *strcpy();
    FILE *fopen();

    char *rp;
    char transfile[BUFSIZ];
    char groupname[BUFSIZ];
    char isopath[BUFSIZ];
    char isobuf[BUFSIZ];
    FILE *fp; 
    int  cmpsts;


    /*
    ** If the translation type is TYPE_UNIX then just convert
    ** the '.'s to '/'s
    */

    if (type == TYPE_UNIX) {
        (void) strcpy(diskpath,ngname);
        rp = diskpath;
        while (*rp)  {
            if (*rp == '.')
                *rp = '/';
            ++rp;
        }
        return(1);    /* found */
    }

    /*
    ** ISO lookup time...
    */

    (void)sprintf(transfile, "%s/%s%s", libpath, PATH_TRANS_FILE, 
		iso_extension);

#ifdef PATH_DEBUG
printf("findpath() trying to open [%s]\n", transfile);
#endif

    if ((fp = fopen(transfile,"r")) == NULL) {
        (void) fprintf(stderr,"findpath can't open %s\n", transfile);
        return(-1);   /* error */
    }
    
    while (fgets(isobuf, sizeof(isobuf), fp) != NULL) {
	if (*isobuf == '#')     /* skip comments */
            continue;

        /*
        ** If the line does not have two entries on it
        ** then silently ignore it.
        */

        if (sscanf(isobuf,"%s %s", groupname, isopath) != 2)
            continue;

        if ((cmpsts = strcmp(ngname, groupname)) == 0) {
            (void) fclose(fp);
            (void) strcpy(diskpath, isopath);
            return(1);  /* found */
        } else if (cmpsts < 0)
	    break; /* the list is sorted, so we won't find it after this */
    }

    (void) fclose(fp);
    return(0); /* not found... */
}
