#ifndef lint
static char	*sccsid = "@(#)newgroups.c	1.13	(Berkeley) 2/6/88";
#endif

#include "common.h"
#include "time.h"
#include "spooldir.h"

extern struct newscontrol newscont;

FILE	*date_fp;
static char	**dist_list = (char **) NULL;
int		distcount = 0;
long		date;

/*
 * NEWGROUPS date time ["GMT"] [<distributions>]
 *
 * Display new newsgroups since a given date and time, but only
 * for those in <distributions>.
 */

newgroups(argc, argv)
int		argc;
char		*argv[];
{
    char line[80];

    state_cb.state = SINGLE_RESP_STATE;
    if (argc < 3) {
        (void) sprintf(response_text, 
          "%d Usage: NEWGROUPS yymmdd hhmmss [\"GMT\"] [<distributions>].\r\n",
			ERR_CMDSYN);
	return;
    }

#ifdef PATH_DEBUG
    printf("clientlib - newgroups() trying to open [%s]\n", 
		newscont.active_times);
#endif
    date_fp = fopen(newscont.active_times, "r");
    if (date_fp == NULL) {
	(void) sprintf(response_text, 
                "%d Cannot open newsgroup date file.\r\n", ERR_FAULT);
	return;
    }

    /*	    YYMMDD		    HHMMSS	*/
    if (strlen(argv[1]) != 6 || strlen(argv[2]) != 6) {
	(void) sprintf(response_text, 
                "%d Date/time must be in form YYMMDD HHMMSS.\r\n", ERR_CMDSYN);
	(void) fclose(date_fp);
        return;
    }

    (void) strcpy(line, argv[1]);			/* yymmdd */
    (void) strcat(line, argv[2]);			/* hhmmss */

    date = dtol(line);
    if (date < 0) {
	(void) sprintf(response_text, 
                "%d Invalid date specification.\r\n", ERR_CMDSYN);
	(void) fclose(date_fp);
	return;
    }

    argc -= 3;
    argv += 3;

    if (argc > 0 && !strcasecmp(*argv, "GMT")) { /* We store stuff in GMT */
        ++argv;					/* anyway, so this is */
        --argc;					/* a "noop" */
    } else 					/* But that means not GMT */
	date = local_to_gmt(date);		/* is a definite "op" */

    if (argc > 0) {
	distcount = get_distlist(&dist_list, *argv);
	if (distcount < 0) {
            (void) sprintf(response_text, 
                           "%d Bad distribution list %s:\r\n", *argv);
	    (void) fclose(date_fp);
	    return;
	}
    }

    (void) sprintf(response_text, 
            "%d New newsgroups since %s follow.\r\n", OK_NEWGROUPS, line);
    state_cb.state = NEWGROUPS_STATE;
    return;
}


newgroups_read()
{
    register char	*cp, *temp;
    int		i;

    while (fgets(response_text, NNTP_STRLEN, date_fp) != NULL) {
	if ((cp = index(response_text, '\n')) != NULL)
	    *cp = '\0';
	if ((cp = index(response_text, ' ')) != NULL)
	    *cp = '\0';
	if (atoi(cp + 1) < date)
	    continue;

	if (distcount == 0) {
            return; /* let a call to get_server get this line */
	} else {
	    temp = response_text;
	    cp = index(temp, '.');
	    if (cp == NULL)
		continue;
	    *cp = '\0';
	    for (i = 0; i < distcount; ++i)
		if (strcmp(temp, dist_list[i]) == 0) {
		    *cp = '.';
                    return; /* let a call to get_server get this line */
		}
	}
    }
    state_cb.state = SINGLE_RESP_STATE;
    (void) strcpy(response_text, ".\r\n");
    (void) fclose(date_fp);
}
