#ifndef lint
static char	*sccsid = "@(#)$Header: spldir.c,v 1.0 92/03/23 23:47:40 sob Exp $";
#endif

#include "common.h"
#include "spooldir.h"
#include "nntp.h"

struct spooldir spdir;
struct newscontrol newscont;

extern struct spooldir *getspoolent();

int listspool;

/*
 * SPOOLDIR [spooldir alias]
 *
 * if no spooldir alias is specified, list the valid spooldir's,
 * else switch to specified spooldir.
 *
 */

spldir(argc, argv)
register int	argc;
char		*argv[];
{
    if (argc > 2) {
        state_cb.state = SINGLE_RESP_STATE;
        (void) sprintf(response_text,
                  "%d Usage: %s [spooldir-alias].\r\n", ERR_CMDSYN, argv[0]);
        return;
    }

    listspool = 0; /* default to not "spooldir list" */

    if (argc == 2) {
	if (strcasecmp(argv[1], "list") != 0) {
            /* If told to switch to current spooldir, just say "fine" */
            if (strcmp(argv[1], spdir.name) == 0) {
                state_cb.state = SINGLE_RESP_STATE;
                (void) sprintf(response_text,
                     "%d Still using %s spooldir\r\n", OK_SPNOCHANGE, argv[1]);
                return;
            }
            switch(getspooldir(argv[1], &spdir)) {
            case 1:   /* found a valid spooldir */
                server_init("oh-boy"); /* parameter doesn't matter */
                state_cb.state = SINGLE_RESP_STATE;
                (void) sprintf(response_text,
                     "%d Switching to %s spooldir\r\n", OK_SPSWITCH, argv[1]);
                return;
            case 0:   /* spooldir named not found in spooldir file */
                 state_cb.state = SINGLE_RESP_STATE;
                 (void) sprintf(response_text,
                     "%d Invalid spooldir alias %s\r\n", ERR_INVALIAS, argv[1]);
                 return;
            case -1: /* spooldir named found in spooldir file but not mounted */
                 state_cb.state = SINGLE_RESP_STATE;
                 (void) sprintf(response_text,
                     "%d spooldir %s not currently available\r\n", 
                         ERR_INVALIAS, argv[1]);
                 return;
            case -2: 
                 state_cb.state = SINGLE_RESP_STATE;
                 (void) sprintf(response_text,
                     "%d No spooldir file found at %s\r\n",
                         ERR_INVNOSPDIR,SPOOLDIRS_FILE);
                 return;
            }
	} else
	    listspool = 1; /* process "spooldir list" */
    }

#ifdef PATH_DEBUG
    printf("clientlib spldir() - current [%s] [%s] [%s] [%s] [%d]\n", 
		spdir.name, spdir.mntpoint, spdir.dirpath, spdir.libpath, spdir.transtype);
#endif
    /* Client wants a list of spooldir alias' */
    state_cb.state = SPOOLDIR_STATE;
    (void) sprintf(response_text, 
        "%d SPOOLDIR list coming:\r\n", OK_SPLIST);
    setspoolent(); /* open spooldir config file */
    return;
}


spldir_read()
{
    struct spooldir *sp;
    int spldir_sts;
    char *type_ptr;

    /* If listing all entries in the spooldir file */
    if (listspool) {
        if ((sp = getspoolent(&spldir_sts)) != NULL) {
	    if (sp->transtype == TYPE_ISO)
		type_ptr = "iso";
	    else
		type_ptr = "unix";
	    if (strcmp(spdir.name, sp->name) == 0) /* current */
                (void) sprintf(response_text, "%d %s %s %s %s %s %s", 
			OK_SPLDIRCUR, sp->name, sp->mntpoint, sp->libpath,
			sp->dirpath, type_ptr, sp->descrip); 
	    else if (spldir_sts == 1)  /* available */
                (void) sprintf(response_text, "%d %s %s %s %s %s %s", 
			OK_SPLDIRAVL, sp->name, sp->mntpoint, sp->libpath, 
			sp->dirpath, type_ptr, sp->descrip); 
	    else /* unavailable */
                (void) sprintf(response_text, "%d %s %s %s %s %s %s", 
			OK_SPLDIRERR, sp->name, sp->mntpoint, sp->libpath,
			sp->dirpath, type_ptr, sp->descrip); 
            return; /* let a call to get_server get this line */
        }
    } else { /* just return alias' of available spooldir entries */
	while ((sp = getspoolent(&spldir_sts)) != NULL) {
	    if (spldir_sts == 1) {	
                (void) sprintf(response_text, "%s", sp->name); 
                return; /* let a call to get_server get this line */
	    }
        }
    }

    endspoolent(); /* close spooldir config file */
    (void) strcpy(response_text, ".");
    state_cb.state = NULL_STATE;
    listspool = 0;
    return;
}
