#ifndef lint
static char     *sccsid = "@(#)state.c  1.0 92/03/23 tat Exp $";
#endif

#include "common.h"

/*
 * state() - process current state of the reader session.
 */

char *state()
{
    switch (state_cb.state) {
    case XTHREAD_STATE :
    case SINGLE_RESP_STATE :
        state_cb.state = NULL_STATE;
        break;
    case LIST_STATE :
        state_cb.state = LIST_READ_STATE;
        break;
    case LIST_READ_STATE :
        (void) list_read();
        break;
    case NEWGROUPS_STATE :
        state_cb.state = NEWGROUPS_READ_STATE;
        break;
    case NEWGROUPS_READ_STATE :
        (void) newgroups_read();
        break;
    case AHBS_STATE :
        state_cb.state = AHBS_READ_STATE;
        break;
    case AHBS_READ_STATE :
        (void) ahbs_read();
        break;
    case XHDR_STATE :
        state_cb.state = XHDR_READ_STATE;
        break;
    case XHDR_READ_STATE :
        (void) xhdr_read();
        break;
    case XHDR_MSG_ID_STATE :
        state_cb.state = XHDR_MSG_ID_READ_STATE;
        break;
    case XHDR_MSG_ID_READ_STATE :
        (void) xhdr_msg_id_read();
        break;
    case SPOOLDIR_STATE :
        state_cb.state = SPOOLDIR_READ_STATE;
        break;
    case SPOOLDIR_READ_STATE :
        spldir_read();
        break;
    case HELP_STATE :
        if (state_cb.help_index == HELP_ARRAY_MAX)
            state_cb.state = NULL_STATE;
        return(help_text[state_cb.help_index++]);
    default : /* NULL_STATE */
        return("\0");
    }
    return(response_text);
}
